/****************************************************************************************/
/**************PROGRAMA QUE MUESTRA NUMERO DE CICLOS EN GRAFO DIRIGIDO*******************/
/****************************************************************************************/
/*******************************************************by Javier Giovannini C.**********/
/****************************************************************************************/
//VARIABLES GLOBALES
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#define TAMANO_LINEA 256
/****************************************************************************************/

int *d, *f, *p, *color, time, nciclos;
int i,j, **A;

/****************************************************************************************/
/****************************************************************************************/
main(int arg, char *argv[]){
	int n, cont=0;
	int i,j,k,vertice,adyacente;
	char linea[TAMANO_LINEA], *dato;
	FILE* archivo; /* archivo= puntero del archivo */
	if(argv[1]){
	archivo=fopen(argv[1],"r+"); /*abrimos archivo con la lista */
	fscanf(archivo,"%d",&n); /*escaneamos numero de filas a partir de archivo de lista */
	

	A=(int **)malloc(n*sizeof(int)); /*creamos matriz A de tama� nxn */
		for(i=0;i<n;i++)
			A[i]=(int *)malloc(n *sizeof(int));  

	for(i=0; i<n; i++){ /* llenamos matriz A nxn de ceros */
		for(j=0;j<n;j++){
			A[i][j]=0;}
	}


/****************************************************************************************/
// LEE ARCHIVO Y CREA MATRIZ DE ADYACENCIA
	for (i=0; i<=n; i++) {
    fgets(linea, TAMANO_LINEA, archivo);  /*lee una linea completa */
    vertice=atoi(strtok(linea," \t"));  /* asume espacios o tabuladores como separadores */

    while((dato=strtok(NULL," \t")) != NULL){
      adyacente=atoi(dato);
	  A[vertice][adyacente]=1; /* llena la matriz de adyacencia */
    }
  }
	// contamos el numero de vertices
	for(i=0;i<n;i++){
		for(j=0;j<n;j++){
			if(A[i][j]==1) cont++;
		}
	}

/****************************************************************************************/
// MUESTRA EN PANTALLA LA MATRIZ (activar si se desea)
/*
for(i=0;i<n;i++){
	for(j=0;j<n;j++){
	printf("%d ",A[i][j]);
	}
	printf("\n");
	}*/
/****************************************************************************************/
//SE LLAMA A LA FUNCION Deep First Search Y HACE EL DESPLIEGUE EN PANTALLA

	system("clear"); //limpia la pantalla
		DFS(A,n); // llama a funcion DFS (que imprime los ciclos si los hay)
	
		if(nciclos==0) { // si no hay ciclos se ejecuta
			printf("NO HAY CICLOS\n");
			printf("arcos:%d < nodos:%d\n", cont,n);
			}
		
		else {
			//nos muestra el numero de ciclos, arcos y nodos
			printf("\nCICLOS=%2d, arcos:%d > nodos:%d\n",nciclos, cont,n);
		}

fclose(archivo);

}
/****************************************************************************************/
/* MUESTRA MENSAJE DE ERROR SI NO SE INGRESA ARGUMENTO */
else{
	printf("ERROR: ingresar nombre de archivo como argumento\n");
	printf("Ejemplo: $./ciclos lista.txt\n");
	}
}
/****************************************************************************************/
/****************************************************************************************/



